// src/backend/static_thread.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "static_thread.hh"
using namespace sgpem;

StaticThread::StaticThread(const Glib::ustring& name,
                           StaticProcess& process,
                           unsigned int arrival_time,
                           int base_priority) :
  StaticSchedulable(name, arrival_time, 0, base_priority),
  _start_time_delta(arrival_time), _required_cpu_time(0),
  _process(&process)
{
}

// FIXME unmcomment when StaticSchedulable complies to the design
// unsigned int StaticThread::get_total_cpu_time() const
// {
//   return _required_cpu_time;
// }
// 
// unsigned int StaticThread::get_arrival_time() const
// {
//   return _start_time_delta;
// }
// 
// void StaticThread::set_arrival_time(unsigned int time)
// {
//   _start_time_delta = time;
// }

StaticProcess& StaticThread::get_process()
{
  return *_process;
}

